export interface ArticleItem {
    title: string;
    date: string;
    tags: string[];
    categories: string[];
    content: string;
}
export interface Config {
    /**
     * 用户
     */
    userId: string;
    /**
     * 输出路径
     */
    output: string;
    /**
     * cookie?
     */
    cookie?: string;
    imgConfig?: string;
}
export declare abstract class Base<TConfig extends Config = Config> {
    config: TConfig;
    /**
     * 请求头
     */
    protected abstract headers: Record<string, string>;
    constructor(config: TConfig);
    run(): Promise<ArticleItem[]>;
    getMain(): Promise<any[]>;
    getDetail(id: string | number): Promise<ArticleItem>;
    /**
     * 生成文件后的操作
     */
    generateSuccess(file: string[]): Promise<void>;
}
